#include <iostream>
#include "seznam.h"
using namespace std;

void vytvor(Seznam &s)
{
	s.hlava = new Prvek;
	s.zarazka = s.hlava;
	s.hlava->dalsi = nullptr;
}

void vyprazdni(Seznam &s)
{
	Prvek *p;
	while (s.hlava != s.zarazka)
	{
		p = s.hlava;
		s.hlava = p->dalsi;
		delete p;
	}
}

void zrus(Seznam &s)
{
	vyprazdni(s);
	delete s.hlava;
	s.hlava = nullptr;
	s.zarazka = nullptr;
}

bool jePrazdny(Seznam &s)
{
	return (s.hlava == s.zarazka);
	/*if (s.hlava == s.zarazka)
		return true;
	return false;*/
}

void vlozNaZacatek(Seznam &s, const T &co)
{
	Prvek *p = new Prvek;
	p->data = co;
	p->dalsi = s.hlava;
	s.hlava = p;
}

void vlozNaKonec(Seznam &s, const T &co)
{
	s.zarazka->data = co;
	s.zarazka->dalsi = new Prvek;
	s.zarazka = s.zarazka->dalsi;
	s.zarazka->dalsi = nullptr;
}

void vypis(int x)
{
	cout << x << " ";
}

void vypis(const Zamestnanec &z)
{
	cout << z.ID << " " << z.jmeno << " " << z.prijmeni << " " << z.plat << endl;
}

void vypis(Seznam &s)
{
	cout << "Seznam: \n";
	Prvek *p = s.hlava;
	while (p != s.zarazka)
	{
		vypis(p->data);
		p = p->dalsi;
	}
	cout << endl;
}

T vyjmiPrvni(Seznam &s)
{
	if (jePrazdny(s))
		throw 1;
	// TODO
	return s.hlava->data;

}
void smazPrvni(Seznam &s)
{

	if (!jePrazdny(s))
		vyjmiPrvni(s);

	/*
	try
	{
		vyjmiPrvni(s);
	}
	catch (...)
	{

	}
	*/
}

Prvek *najdi(Seznam &s, const T&co)
{
	return nullptr;
}

T *najdi1(Seznam &s, const T&co)
{
	Prvek *p = najdi(s, co);
	if(!p)
		return nullptr;
	return &(p->data);
}

T &najdi2(Seznam &s, const T&co)
{
	Prvek *p = najdi(s, co);
	if (!p)
		throw 1;
	return p->data;
}

void vlozZa(Seznam &s, Prvek *zaKtery, const T&co)
{

}

T vyjmiPrvekZa(Seznam &s, Prvek *predchazejici)
{
	throw 1;
}

void smazPrvekZa(Seznam &s, Prvek *predchazejici)
{
	if (predchazejici && (predchazejici != s.zarazka) && (predchazejici->dalsi!=s.zarazka))
		vyjmiPrvekZa(s, predchazejici);
}

void smazPrvek(Seznam &s, Prvek *mazany)
{

}

T* maximum(Seznam &s)
{
	return nullptr;
}

void setrid(Seznam &s)
{

}

