#pragma once
#include <string>
using namespace std;

#define N 10
#undef N

// #define ZAMESTNANEC
// #undef ZAMESTNANEC

struct Zamestnanec
{
	unsigned int ID;
	string jmeno;
	string prijmeni;
	unsigned int plat;
};

#ifdef ZAMESTNANEC
using T = Zamestnanec;
#else
using T = int;
#endif
// typedef int T;

struct Prvek
{
	T data;
	Prvek *dalsi = nullptr;
};

struct Seznam
{
	Prvek *hlava = nullptr;
	Prvek *zarazka = nullptr;
};

void vytvor(Seznam &s);
void vyprazdni(Seznam &s);
void zrus(Seznam &s);
bool jePrazdny(Seznam &s);

void vlozNaZacatek(Seznam &s, const T&co);
void vlozNaKonec(Seznam &s, const T&co);
void vypis(Seznam &s);

T vyjmiPrvni(Seznam &s);
void smazPrvni(Seznam &s);

Prvek *najdi(Seznam &s, const T&co);
T     *najdi1(Seznam &s, const T&co);
T     &najdi2(Seznam &s, const T&co);

void vlozZa(Seznam &s, Prvek *zaKtery, const T&co);
T vyjmiPrvekZa(Seznam &s, Prvek *predchazejici);
void smazPrvekZa(Seznam &s, Prvek *predchazejici);

void smazPrvek(Seznam &s, Prvek *mazany);
T* maximum(Seznam &s);
void setrid(Seznam &s);
